// ======================================================================
//
// MenuRectangle.cpp
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#include "First.h"
#include "MenuRectangle.h"

#include "Gl.h"
#include "Iff.h"
#include "Material.h"

// ======================================================================

const Tag TAG_FILL = TAG(F,I,L,L);

// ======================================================================

MenuRectangle::MenuRectangle(MenuElement *newParent, int maxWidth, int maxHeight, Iff *iff)
: MenuElement(newParent, maxWidth, maxHeight, NULL)
{
	color = MaterialList::white();
	filled = false;

	load(iff);
}

// ----------------------------------------------------------------------

MenuRectangle::~MenuRectangle(void)
{
}

// ----------------------------------------------------------------------

void MenuRectangle::load(Iff *iff)
{
	if (iff)
	{
		MenuElement::load(iff);

		if (iff->seekChunk(TAG_COLR, Iff::FlagOptional))
		{
			int r, g, b;

			r = iff->read_u_int8();
			g = iff->read_u_int8();
			b = iff->read_u_int8();
			iff->exitChunk();

			color = MaterialList::fetch(r,g,b);
		}

		if (iff->seekChunk(TAG_FILL, Iff::FlagOptional))
		{
			filled = true;
			iff->exitChunk();
		}
	}
}

// ----------------------------------------------------------------------

void MenuRectangle::menuDraw(int x, int y) const
{
	Gl::setMaterial(color);
	Gl::rect(menuRect.x0 + x, menuRect.y0 + y, menuRect.x1 + x, menuRect.y1 + y);

	MenuElement::menuDraw(x, y);
}

// ======================================================================
